#include <stdio.h>
#include <stdbool.h>

#define playerX 1
#define playerO 2
#define BLANK 0

bool tripletExists(int board[3][3], int player) {
    // κύρια διαγώνιος
    bool triliza = true;
    for (int i = 0; i < 3; ++i) {
        if (board[i][i] != player) {
            triliza = false;
            break;
        }
    }

    if (triliza/* == true*/) {
        return true;
    }

    // άλλη διαγώνιος
    triliza = true;
    for (int i = 0; i < 3; ++i) {
        if (board[i][2 - i] != player) {
            triliza = false;
            break;
        }
    }

    if (triliza/* == true*/) {
        return true;
    }

    // κάθε γραμμή
    for (int j = 0; j < 3; ++j) {

        triliza = true;
        for (int i = 0; i < 3; ++i) {
            if (board[j][i] != player) {
                triliza = false;
                break;
            }
        }
        if (triliza/* == true*/) {
            return true;
        }

    }

    // κάθε στήλη
    for (int j = 0; j < 3; ++j) {

        triliza = true;
        for (int i = 0; i < 3; ++i) {
            if (board[i][j] != player) {
                triliza = false;
                break;
            }
        }
        if (triliza/* == true*/) {
            return true;
        }

    }

    return false;
}

int playersTurn(int board[3][3]) {
    int countX = 0;
    int countO = 0;

    // για κάθε γραμμή του board
    for (int r = 0; r < 3; ++r) {
        // για κάθε κελί/στήλη της γραμμής
        for (int c = 0; c < 3; ++c) {
            int content = board[r][c];

            // A' τρόπος
            if (content == playerX) {
                countX++;
            } else if (content == playerO) {
                countO++;
            } else if (content != BLANK) {
                // Αν δεν είναι BLANK, και αφού δεν είναι ούτε playerX ή playerO τότε κάτι δεν πάει καλά
                return -1;
            }

            // B' τρόπος
//            switch (board[r][c]) {
//                case playerX:
//                    countX++;
//                    break;
//                case playerO:
//                    countO++;
//                    break;
//                case BLANK:
//                    break;
//                default:
//                    return -1;
//            }
        }
    }

    /**
     * ΠΡΟΣΟΧΗ! Εδώ η σειρά των ελέγχων παίζει ρόλο επειδή η συνθήκη
     *      countX + countO == 9
     * για 5+4 είναι μια ΕΙΔΙΚΗ ΠΕΡΙΠΤΩΣΗ της
     *      countX == countO + 1
     * πρώτα θα πρέπει να ελεγχθεί η ειδική περίπτωση και μετά η γενική!!
     */
    if (countX + countO == 9) {         // Αν έχουν παιχτεί και οι 9 κινήσεις, τότε δεν είναι σειρά κανενός
        return -1;
    } else if (countX == countO) {      // Αν έχουν παίξει και οι 2 παίκτες τις ίδιες φορές, τότε παίζει ο X
        return playerX;
    } else if (countX == countO + 1) {  // Αν έχει παίξει ο Χ μια φορά παραπάνω από τον Ο, τότε παίζει ο Ο
        return playerO;
    } else {                            // Σε κάθε άλλη περίπτωση δεν είμαστε σε σωστή κατάσταση!
        return -1;
    }
}

int main() {
    // φτιάχνω ένα board για να δοκιμάζω
    int board1[3][3] = {
            { playerX,   BLANK, playerO },
            {   BLANK, playerX, playerO },
            {   BLANK,   BLANK,   BLANK }
    };

    // καλώ τις συναρτήσεις μου για
    if (tripletExists(board1, playerX)) {
        printf("X is the winner!\n");
    } else if (tripletExists(board1, playerO)) {
        printf("O is the winner\n");
    } else {    // ή είναι σειρά κάποιου να παίξει
        if( playersTurn(board1) == playerX ) {  // του Χ
            printf("Players X turn\n");
        } else if( playersTurn(board1) == playerO ) {   // του Ο
            printf("Players O turn\n");
        } else {    // αλλιώς είτε τελείωσε το παιχνίδι, είτε είναι λάθος το board
            printf("It's a draw (or the board is 'broken')!");
        }
    }

    return 0;
}
